<?php
/* utf8-marker = äöüß */

/*
 * Repo_XH
 *
 * @author  Olaf Penschke	olape
 * @version 1.0 beta2 (28.02.2019)
 * @link    http://olaf.penschke.net/

 * @license http://www.gnu.org/licenses/gpl-3.0.en.html GNU GPLv3

================================================================================
*/
include_once($pth['folder']['plugins'] . 'repoxh/adminfuncs.php');
//*********************************************************************************************
/*
 * Check if PLUGINLOADER is calling and die if not.
 */
if(!defined('PLUGINLOADER')) {
	die(
		'Plugin '. basename(dirname(__FILE__))
		. ' requires a newer version of the Pluginloader. No direct access.'
	);
}

//*********************************************************************************************
// dynamisches Menü unter Plugin
if(function_exists('XH_registerStandardPluginMenuItems')) {
	XH_registerStandardPluginMenuItems(true);
}
//*********************************************************************************************
// zusätzlicher Menüpunkt im dynamischen Menü
XH_registerPluginMenuItem(
$plugin, 
$plugin_tx['repoxh']['backend_show_data'], 
'?&repoxh&admin=plugin_data&action=plugin_text&normal', 
''
);
//
XH_registerPluginMenuItem(
$plugin, 
$plugin_tx['repoxh']['menu_sources'], 
'?&repoxh&admin=plugin_sources&action=plugin_text&normal', 
''
);
//*********************************************************************************************
if(XH_wantsPluginAdministration('repoxh')) {
	// zusätzliche Zeile und Tab im Adminmenü
	$o .= print_plugin_admin('on');
	pluginmenu('ROW');
	pluginmenu(
		'TAB', 
		'?&repoxh&admin=plugin_data&action=plugin_text&normal', 
		'', 
		XH_hsc($plugin_tx['repoxh']['backend_show_data'])
	);
	pluginmenu(
		'TAB', 
		'?&repoxh&admin=plugin_sources&action=plugin_text&normal', 
		'', 
		XH_hsc($plugin_tx['repoxh']['menu_sources'])
	);
	$o .= pluginmenu('SHOW');

//*********************************************************************************************
// Menü in der Pluginkopfzeile
	if(($admin != 'plugin_main') && ($admin != ''))
	{
		$o .= plugin_admin_common($action, $admin, $plugin);
	}
//*********************************************************************************************
//*********************************************************************************************
	$op_plugin_name = 'Repo_XH';
	$op_plugin_version = '1.0 beta2';
	$op_copyright = '2019 - ' . date('Y');
	$op_cms_version_arr = array('1.7.0','1.7.1','1.7.2');
	$op_php_version = '5.6';
//*********************************************************************************************
//*********************************************************************************************
	if(($admin == '') || ($admin == 'plugin_main'))	//Anzeige nur auf Startseite des Plugins
	{
		$o .= '<div class="repoxh_admin">';
		/*$o .= "\n" . '<h1>'
		   . ucfirst(str_replace('_', ' ', $plugin)) . '</h1>';*/

		$o .= '<img class="repoxh_admin_logo" alt="Logo Repo_XH" src="' . $pth['folder']['plugins'] . 'repoxh/img/logo-repo_xh-200.png">';
		$o .= "\n".'<h1>Plugin "' . $op_plugin_name . '" for CMSimple_XH</h1>
		<p>Version: ' . $op_plugin_version . '</p>
		<p>' . $op_plugin_name . ', Copyright © ' . $op_copyright . ' <a target="_blank" href="http://olaf.penschke.net/?CMSimple_XH/Plugins">Olaf Penschke</a></p>
		<p> </p>
		<p><a target="_blank" href="http://olaf.penschke.net/?Kontakt&xh_mailform_subject=' . $op_plugin_name . '">Gern nehme ich auch Informationen entgegen, auf welchen Seiten das Plugin eingesetzt wird.</a></p>
		<p> </p>
		<p><b>' . $op_plugin_name . '</b> kann unter Einhaltung der <a target="_blank" href="https://www.gnu.org/licenses/gpl-3.0.de.html">GPLv3</a> verwendet werden.</p>
		<hr>
		<p>Adapted for CMSimple_XH ' . $op_cms_version_arr[0] . ' - ' . end($op_cms_version_arr) . ' by <a target="_blank" href="http://www.cmsimple-xh.org/">cmsimple-xh.org</a></p>';
//*********************************************************************************************
// System check
//*********************************************************************************************
		$o .= '<h4>System check</h4>';
// cURL installiert / aktiviert
		$o .= '<ul style="list-style-type: none;">' . "\n";
		if(function_exists('curl_init')) {
				$o .= '<li><span style="color: #009966; font-size: 20px">&#x2714 &#x263A </span>' 
				   . ' cURL &#x2192 is installed</li>' 
				   . "\n";
			} else {
				$o .= '<li><span style="color: #ff0000; font-size: 20px">&#x2718 &#x2639 </span>' 
				   . ' cURL &#x2192 is not installed</li>' 
				   . "\n";
			}
// GD Support verfügbar
		if(extension_loaded('gd')) {
				$o .= '<li><span style="color: #009966; font-size: 20px">&#x2714 &#x263A </span>' 
				   . ' GD Support &#x2192 is available</li>' 
				   . "\n";
			} else {
				$o .= '<li><span style="color: #ff0000; font-size: 20px">&#x2718 &#x2639 </span>' 
				   . ' GD Support &#x2192 is not available</li>' 
				   . "\n";
			}
// hi_fancybox
		if(function_exists('fancybox')) {
			$o .= '<li><span style="color: #009966; font-size: 20px">&#x2714 &#x263A </span>' 
			   . ' hi_FancyBox &#x2192 is installed</li>' 
			   . "\n";
		} else {
			$o .= '<li><span style="color: #ff0000; font-size: 20px">&#x2718 &#x2639 </span>' 
			   . ' hi_FancyBox &#x2192 is not installed</li>' 
			   . "\n";
		}
// tablesorter
		if(function_exists('tablesorter')) {
			$o .= '<li><span style="color: #009966; font-size: 20px">&#x2714 &#x263A </span>' 
			   . ' Tablesorter_XH &#x2192 is installed</li>' 
			   . "\n";
		} else {
			$o .= '<li><span style="color: #ff0000; font-size: 20px">&#x2718 &#x2639 </span>' 
			   . ' Tablesorter_XH &#x2192 is not installed</li>' 
			   . "\n";
		}
// Fa_XH
		//if (function_exists('fa_require')) {
		if(class_exists('Fa\\RequireCommand')) {
			$o .= '<li><span style="color: #009966; font-size: 20px">&#x2714 &#x263A </span>' 
			   . ' Fa_XH &#x2192 is installed</li>' 
			   . "\n";
		} else {
			$o .= '<li><span style="color: #ff0000; font-size: 20px">&#x2718 &#x2639 </span>' 
			   . ' Fa_XH &#x2192 is not installed</li>' 
			   . "\n";
		}
		$o .= '</ul>' . "\n";
// CMSimple_XH Version
		$op_cms_version_tmp = CMSIMPLE_XH_VERSION;
		$op_cms_version_tmp = str_replace(array('CMSimple_XH '), '', $op_cms_version_tmp);
		$o .= '<ul style="list-style-type: none;">' . "\n";
		if(in_array($op_cms_version_tmp, $op_cms_version_arr, true)) {
			$o .= '<li><span style="color: #009966; font-size: 20px">&#x2714 &#x263A </span>' 
			   . CMSIMPLE_XH_VERSION 
			   . ' &#x2192 supported</li>' 
			   . "\n";
		} else {
			$o .= '<li><span style="color: #ffcc00; font-size: 20px">&#x2714 &#x263A </span>' 
			   . CMSIMPLE_XH_VERSION 
			   . ' &#x2192 I hope it is still supported. It was designed for ' 
			   . $op_cms_version_arr[0] 
			   . ' - ' 
			   . end($op_cms_version_arr) 
			   . '.</li>' 
			   . "\n";
		}
		$o .= '</ul>' . "\n";
// PHP Version
		$o .= '<ul style="list-style-type: none;">' . "\n";
		if(version_compare(phpversion(), $op_php_version, '<')) {
			$o .= '<li><span style="color: #ff0000; font-size: 20px">&#x2718 &#x2639 </span>PHP: ' 
			   . phpversion() 
			   . ' &#x2192 not supported</li>' 
			   . "\n";
		} else {
			$o .= '<li><span style="color: #009966; font-size: 20px">&#x2714 &#x263A </span>PHP: ' 
			   . phpversion() 
			   . ' &#x2192 supported</li>' 
			   . "\n";
		}
		$o .= '</ul>' . "\n";
// Schreibrechte
		$op_filename_arr = array($pth['folder']['plugins'] . 'repoxh/config/config.php', 
								 $pth['folder']['plugins'] . 'repoxh/languages/' . $sl . '.php', 
								 $pth['folder']['plugins'] . 'repoxh/source/plugin.dat', 
								 $pth['folder']['plugins'] . 'repoxh/source/template.dat', 
								 $pth['folder']['plugins'] . 'repoxh/changes/', 
								 $pth['folder']['plugins'] . 'repoxh/config/', 
								 $pth['folder']['plugins'] . 'repoxh/img_tmp/',
								 $pth['folder']['plugins'] . 'repoxh/languages/', 
								 $pth['folder']['plugins'] . 'repoxh/source/', 
								 $pth['folder']['plugins'] . 'repoxh/target/', 
								 $pth['folder']['plugins'] . 'repoxh/sha256/plugin/', 
								 $pth['folder']['plugins'] . 'repoxh/sha256/template/');
		$o .= '<ul style="list-style-type: none;">' . "\n";
		foreach($op_filename_arr as $op_filename) {
			if(is_writable($op_filename)) {
				$o .= '<li><span style="color: #009966; font-size: 20px">&#x2714 &#x263A </span>' 
				   . $op_filename 
				   . ' &#x2192 writable</li>' 
				   . "\n";
			} else {
				$o .= '<li><span style="color: #ff0000; font-size: 20px">&#x2718 &#x2639 </span>' 
				   . $op_filename . ' &#x2192 not writable</li>' 
				   . "\n";
			}
		}
	$o .= '</ul>' . "\n";
	$o .= '</div>';
	}
//*********************************************************************************************
// Anzeige unter data --> Daten anzeigen
		if($admin == 'plugin_data') {
			//
			if((isset($_POST['file_delete'])) && (isset($_POST['datafile']))) {											// Leeren der Change-Log's
				$datafile = $_POST['datafile'];
				fclose(fopen($datafile, 'w')); 
			}
			//
			$o .= '<div class="repoxh_admin_main">';
			$o .= '<h4>' . $op_plugin_name . '</h4>';
			$o .= '<h5>' . $plugin_tx['repoxh']['backend_data_cache'] . '</h5>';
			if(repoxh_list_cache('small')) {																			// Listet alle CSV's
				$o .= repoxh_list_cache('full');
				$o .= '<hr>';
			}
			$o .= '<h5>' . $plugin_tx['repoxh']['backend_cron_logs'] . '</h5>';
			$o .= repoxh_list_logs('full');
			$o .= '<hr>';
			$o .= '<h5>' . $plugin_tx['repoxh']['backend_last_changes'] . '</h5>';
			$o .= repoxh_list_changes();
			$o .= '</div>';
		}
//*********************************************************************************************
// Anzeige unter sources --> Quellen bearbieten
		if($admin == 'plugin_sources') {
			//
			if((isset($_POST['save_sources'])) && (isset($_POST['datafile'])) && (isset($_POST['data']))) {				// Speichern der Quellverzeichnisse
				$datafile = $_POST['datafile'];
				$datafile_tmp = $datafile . '.tmp';
				$data = $_POST['data'];
				$fh = fopen($datafile_tmp, 'w');
				$success = fwrite($fh, $data);
				if(!$success) {
					$o .= $plugin_tx['repoxh']['backend_sources_write_error'];
					fclose($fh);
				} else {
					fclose($fh);
					if(file_exists($datafile . '.bak')) {
						unlink($datafile . '.bak');
					}
					rename($datafile, $datafile . '.bak');
					rename($datafile_tmp, $datafile);
				}
				
			}
			//
			$o .= '<div class="repoxh_admin_sources">';
			$o .= '<h4>' . $op_plugin_name . '</h4>';
			$o .= '<h5>' . $plugin_tx['repoxh']['backend_edit_sources'] . '</h5>';
			$o .= repoxh_list_sources();																				// Listet alle DAT's
			$o .= '</div>';
		}
}
//*********************************************************************************************
?>